// kickmail.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "MAPI.h"
#include <windows.h>
#include <commctrl.h>

#define TIMEOUT 3000

void GetNoreadMessage(MAPI::CFolder &folder, MAPI::CMessage **pMessage);
HWND GetMessageDialog(void);
HWND GetFolderDialog(void);
BOOL ShowFolderTreeView(void);

int _tmain(int argc, _TCHAR* argv[])
{
	BOOL showNoRead = FALSE;
	BOOL showDir = FALSE;

	//}EXv
	HCURSOR hWaitCursor = NULL, hOldCursor = NULL;
	if (hWaitCursor = LoadCursor(NULL, IDC_WAIT)) {
		hOldCursor = SetCursor(hWaitCursor);
	}

	//t@C/noread
	std::wstring execName = argv[0];
	if (execName.rfind(_T("kickmailm.exe")) != std::wstring::npos) {
		showNoRead = 1;
	}

	//R}hCK
	for (int i = 1; i < argc; i++) {
		if (wcscmp(argv[i], _T("/noread")) == 0) {
			showNoRead = TRUE;
		} else if (wcscmp(argv[i], _T("/dir")) == 0) {
			showDir = TRUE;
		}
	}

	MAPI::CMAPI mapi;
	MAPI::CSession session;

	//PDX̃AJEgT
	MAPI::CMsgStore &store = session.GetPdxAccount();
	std::wstring accountName = store.GetDisplayName();

	//Mς݃ACeT
	MAPI::CFolder &inbox = store.GetInboxFolder();
	MAPI::CFolder &folder = inbox.GetSubFolder(_T("Mς݃ACe"));

	//Ƀ[\EBhE\ĂΈxB
	HWND hWnd = GetMessageDialog();
	if (hWnd) SendMessage(hWnd, WM_CLOSE, 0, 0);

	//ǃ[T
	MAPI::CMessage *pMessage = NULL;
	if (showNoRead) {
		GetNoreadMessage(folder, &pMessage);
	}

	//ǃ[\
	if (pMessage) {
		//WS003SHł͖IȊǉKv
		if (!pMessage->IsRead()) {
			pMessage->SetRead(TRUE);
		}

		pMessage->Display();
	}

	//tH_\
	folder.MailSwitchToFolder();

/** [es]/noreadΉ悤ƂƂ̖c
	DWORD st = GetTickCount();
	HWND hFolderWnd = GetFolderDialog();
	while (!hFolderWnd || GetForegroundWindow() != hFolderWnd) {
		Sleep(100);
		if (GetTickCount() - st > TIMEOUT) {
			break;
		}
	}

	if (pMessage) {
		hWnd = GetMessageDialog();
		if (hWnd) {
			ShowWindow(hWnd, SW_SHOW);
		}
	}
**/

	//ǃ[\ĂȂ΁Ac[r[\
	if (!pMessage && showDir) {
		Sleep(100); //OI܂ŁAƂ肠҂B
		ShowFolderTreeView();
	}

	//J[\ɖ߂
	if (!hOldCursor) {
		SetCursor(hOldCursor);
	}

	return 0;
}

void GetNoreadMessage(MAPI::CFolder &folder, MAPI::CMessage **pMessage)
{
	MAPI::CMessages messages = folder.GetNoreadMessages();
	BOOL result = (messages.size() > 0);
	if (result) {
		*pMessage = *messages.begin();
	} else {
		*pMessage = NULL;
	}
}

HWND GetMessageDialog(void)
{
	WCHAR text[256];
	HWND hWnd = NULL, hChildWnd = NULL;

	//_CAOTB
	while (TRUE) {
		if (hWnd) {
			hWnd = GetWindow(hWnd, GW_HWNDNEXT);
		} else {
			hWnd = GetWindow(NULL, GW_CHILD);
		}
		if (!hWnd) break;

		//EBhEuDialogvǂׂ
		if (!GetClassName(hWnd, text, 256) || wcscmp(text, _T("Dialog")) != 0) continue;

		//q̃EBhEuWorkervǂׂ
		hChildWnd = GetWindow(hWnd, GW_CHILD);
		if (!hChildWnd) continue;
		if (!GetClassName(hChildWnd, text, 256) || wcscmp(text, _T("Worker")) != 0) continue;

		//̎qEBhEuPIEHTMLvǂׂ
		hChildWnd = GetWindow(hChildWnd, GW_CHILD);
		if (!hChildWnd) continue;
		if (!GetClassName(hChildWnd, text, 256) || wcscmp(text, _T("PIEHTML")) != 0) continue;

		//̎qEBhEȂƂ𒲂ׂ
		hChildWnd = GetWindow(hChildWnd, GW_CHILD);
		if (hChildWnd) continue;

		//Ώ
		break;
	}

	return hWnd;
}

HWND GetFolderDialog(void)
{
	return FindWindow(_T("Inbox.MainWnd"), NULL);
}

BOOL ShowFolderTreeView(void)
{
	WCHAR text[256];

	//[ʂT
	HWND hWnd = GetFolderDialog();
	if (!hWnd) return FALSE;

	//c[r[T
	hWnd = GetWindow(hWnd, GW_CHILD);
	do {
		if (!hWnd) break;
		if (GetClassName(hWnd, text, 256) && wcscmp(text, _T("ToolbarWindow32")) == 0) break;
		hWnd = GetWindow(hWnd, GW_HWNDNEXT);
	} while (TRUE);
	if (!hWnd) return FALSE;

	int ret = 0;

	//m
	HANDLE hMap = CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, sizeof(TBBUTTON), _T("MOMO"));
	if (hMap == NULL) return FALSE;
	LPTBBUTTON lptb = (LPTBBUTTON)MapViewOfFile(hMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
	if (lptb != NULL) {
		ZeroMemory(lptb, sizeof(TBBUTTON));
		UnmapViewOfFile(lptb);

		//g
		ret = SendMessage(hWnd, TB_GETBUTTON, 1, (LPARAM)lptb);
		if (ret) {
			ret = SendMessage(hWnd, WM_COMMAND, (WPARAM)MAKELONG(lptb->idCommand, 0), NULL);
		}
	}
	CloseHandle(hMap);

	return TRUE;
}